/*
 * Copyright COCKTAIL (www.cocktail.org), 1995, 2012 This software 
 * is governed by the CeCILL license under French law and abiding by the
 * rules of distribution of free software. You can use, modify and/or 
 * redistribute the software under the terms of the CeCILL license as 
 * circulated by CEA, CNRS and INRIA at the following URL 
 * "http://www.cecill.info". 
 * As a counterpart to the access to the source code and rights to copy, modify 
 * and redistribute granted by the license, users are provided only with a 
 * limited warranty and the software's author, the holder of the economic 
 * rights, and the successive licensors have only limited liability. In this 
 * respect, the user's attention is drawn to the risks associated with loading,
 * using, modifying and/or developing or reproducing the software by the user 
 * in light of its specific status of free software, that may mean that it
 * is complicated to manipulate, and that also therefore means that it is 
 * reserved for developers and experienced professionals having in-depth
 * computer knowledge. Users are therefore encouraged to load and test the 
 * software's suitability as regards their requirements in conditions enabling
 * the security of their systems and/or data to be ensured and, more generally, 
 * to use and operate it in the same conditions as regards security. The
 * fact that you are presently reading this means that you have had knowledge 
 * of the CeCILL license and that you accept its terms.
 */
package org.cocktail.carambole.server.components;

// Generated by the WOLips Templateengine Plug-in at 7 sept. 2007 07:32:05

import java.util.Enumeration;

import org.cocktail.carambole.server.MyAjaxPage;
import org.cocktail.fwkcktldepense.server.finder.FinderEngagementBudget;
import org.cocktail.fwkcktldepense.server.finder.FinderExercice;
import org.cocktail.fwkcktldepense.server.finder.FinderTypeApplication;
import org.cocktail.fwkcktldepense.server.metier.EOEngagementBudget;
import org.cocktail.fwkcktldepense.server.metier.EOExercice;
import org.cocktail.fwkcktldepense.server.metier.EOTypeApplication;
import org.cocktail.fwkcktldepense.server.metier.EOTypeEtat;
import org.cocktail.fwkcktldepense.server.metier.EOUtilisateur;

import com.webobjects.appserver.WOComponent;
import com.webobjects.appserver.WOContext;
import com.webobjects.appserver.WODisplayGroup;
import com.webobjects.appserver.WOResponse;
import com.webobjects.eocontrol.EOEditingContext;
import com.webobjects.eocontrol.EOOrQualifier;
import com.webobjects.eocontrol.EOQualifier;
import com.webobjects.foundation.NSArray;
import com.webobjects.foundation.NSDictionary;
import com.webobjects.foundation.NSMutableArray;
import com.webobjects.foundation.NSMutableDictionary;
import com.webobjects.foundation.NSTimestamp;

import er.extensions.eof.ERXEC;
import er.extensions.eof.ERXQ;

public class EngagementListe extends MyAjaxPage {

	private static final long serialVersionUID = 1L;
	private String onloadJS = null;
	private NSArray<NSDictionary<String, Object>> lesEngagements = null;
	private NSDictionary<String, Object> unEngagement = null;
	private WODisplayGroup dg = null;
	private NSArray<EOExercice> lesExercices = null;
	private NSArray<EOTypeApplication> lesApplications = null;
	private EOTypeApplication uneApplication = null;
	private EOExercice unExercice = null;

	private Boolean isFiltreEtatEngageeChecked = Boolean.TRUE;
	private Boolean filtreEtatEngagee = Boolean.TRUE;
	private Boolean isFiltreEtatPartiellementSoldeeChecked = Boolean.TRUE;
	private Boolean filtreEtatPartiellementSoldee = Boolean.TRUE;
	private Boolean isFiltreEtatSoldeeChecked = Boolean.TRUE;
	private Boolean filtreEtatSoldee = Boolean.TRUE;

	public EngagementListe(WOContext context) {
		super(context);
		setDgActif(dgEngagement());
	}

	public void appendToResponse(WOResponse res, WOContext ctx) {
		super.appendToResponse(res, ctx);
		if (onloadJS != null)
			onloadJS = null;
	}

	public NSArray<String> itemsMenu() {
		NSArray<String> items = new NSArray<String>(new String[] {
				"Accueil"
		});

		WODisplayGroup dg = dgEngagement();
		if (dg != null && dg.allObjects().count() > 0) {
			items = new NSArray<String>(new String[] {
					"ModifierLaRecherche",
					"Accueil"
			});
		}
		return items;
	}

	public String classForTypeEtatEngagement() {
		String typeEtat = (String) getUnEngagement().objectForKey("TYPEETAT");
		return typeEtat.toLowerCase();
	}

	public WOComponent rechercher() {
		WODisplayGroup dgC = dgCommande();
		dgC.setSelectedObjects(null);
		dgC.setObjectArray(null);
		WODisplayGroup dgF = dgFacture();
		dgF.setSelectedObjects(null);
		dgF.setObjectArray(null);
		WODisplayGroup dgE = getDg();
		@SuppressWarnings("unchecked")
		NSMutableDictionary<String, Object> bdgs = dgE.queryBindings();

		if (bdgs.objectForKey("exercice") == null) {
			EOExercice exercice = FinderExercice.getExercicePourDate(edc(), new NSTimestamp());
			bdgs.setObjectForKey(exercice, "exercice");
		}
		if (bdgs.objectForKey("utilisateur") == null) {
			EOUtilisateur utilisateur = utilisateurInContext(edc());
			bdgs.setObjectForKey(utilisateur, "utilisateur");
		}
		NSMutableArray<String> typesEtatLibelle = new NSMutableArray<String>();
		if (isFiltreEtatEngageeChecked != null && isFiltreEtatEngageeChecked.booleanValue()) {
			typesEtatLibelle.addObject(EOTypeEtat.ENGAGE);
		}
		if (isFiltreEtatPartiellementSoldeeChecked != null && isFiltreEtatPartiellementSoldeeChecked.booleanValue()) {
			typesEtatLibelle.addObject(EOTypeEtat.PART_SOLDE);
		}
		if (isFiltreEtatSoldeeChecked != null && isFiltreEtatSoldeeChecked.booleanValue()) {
			typesEtatLibelle.addObject(EOTypeEtat.SOLDE);
		}
		bdgs.setObjectForKey(typesEtatLibelle, "lesTypesEtat");
		int nbEngagements = FinderEngagementBudget.getRawRowCountEngagementsBudgets(edc(), bdgs);
		if (nbEngagements > 0 && nbEngagements <= 500) {
			lesEngagements = FinderEngagementBudget.getRawRowEngagements(edc(), bdgs);
			session.setAlertMessage(null);
		}
		else {
			lesEngagements = null;
			if (nbEngagements > 500) {
				session.setAlertMessage(nbEngagements + " engagements trouvés. Veuillez affiner la recherche.");
			}
			else {
				session.setAlertMessage("Aucun engagement trouvé.");
			}
		}
		dgE.setObjectArray(lesEngagements);
		//setDg(dgE);
		return filtrer();
	}

	public WOComponent detailler() {
		DetailEngagementBudget nextPage = null;
		NSDictionary<String, Object> engagement = getUnEngagement();
		if (engagement != null) {
			nextPage = (DetailEngagementBudget) pageWithName("DetailEngagementBudget");
			EOEditingContext edc = edc();
			EOEditingContext newEdc = ERXEC.newEditingContext();
			EOExercice exercice = (EOExercice) getDg().queryBindings().objectForKey("exercice");
			exercice = (EOExercice) newEdc.faultForGlobalID(edc.globalIDForObject(exercice), newEdc);
			Number numero = (Number) engagement.objectForKey("NUMERO");
			session.setLEngagementBudgetEnCours(null);
			session.setNestedEdc(newEdc);
			EOEngagementBudget engagementADetailler = FinderEngagementBudget.getEngagementBudget(newEdc, exercice, numero);
			session.setLEngagementBudgetEnCours(engagementADetailler);
			nextPage.setEngagementBudget(engagementADetailler);
		}
		return nextPage;
	}

	@SuppressWarnings("unchecked")
	public WOComponent filtrer() {
		NSMutableDictionary<String, Object> bdgs = dg.queryBindings();

		NSMutableArray<String> typesEtatLibelle = new NSMutableArray<String>();
		if (isFiltreEtatEngageeChecked != null && isFiltreEtatEngageeChecked.booleanValue()) {
			typesEtatLibelle.addObject(EOTypeEtat.ENGAGE);
		}
		if (isFiltreEtatPartiellementSoldeeChecked != null && isFiltreEtatPartiellementSoldeeChecked.booleanValue()) {
			typesEtatLibelle.addObject(EOTypeEtat.PART_SOLDE);
		}
		if (isFiltreEtatSoldeeChecked != null && isFiltreEtatSoldeeChecked.booleanValue()) {
			typesEtatLibelle.addObject(EOTypeEtat.SOLDE);
		}
		bdgs.setObjectForKey(typesEtatLibelle, "lesTypesEtat");
		EOTypeApplication typeApplication = (EOTypeApplication) bdgs.objectForKey("typeApplication");

		lesEngagements = dg.allObjects();
		if (typeApplication != null) {
			bdgs.setObjectForKey(typeApplication, "typeApplication");
			//			EOQualifier qual = EOQualifier.qualifierWithQualifierFormat("TYPEAPPLICATION=%@", new NSArray(typeApplication.tyapLibelle()));
			EOQualifier qual = ERXQ.equals("TYPEAPPLICATION", typeApplication.tyapLibelle());
			lesEngagements = EOQualifier.filteredArrayWithQualifier(lesEngagements, qual);
		}

		if (lesEngagements != null && lesEngagements.count() > 0 &&
				typesEtatLibelle != null && typesEtatLibelle.count() > 0) {
			EOOrQualifier qualTypeEtat = null;
			NSMutableArray<EOQualifier> orQualifiers = new NSMutableArray<EOQualifier>();
			Enumeration<String> enumTypeEtat = typesEtatLibelle.objectEnumerator();
			while (enumTypeEtat.hasMoreElements()) {
				String unEtat = (String) enumTypeEtat.nextElement();
				//				EOQualifier qual = EOQualifier.qualifierWithQualifierFormat("TYPEETAT=%@", new NSArray(unEtat));
				EOQualifier qual = ERXQ.equals("TYPEETAT", unEtat);
				orQualifiers.addObject(qual);
			}
			qualTypeEtat = new EOOrQualifier(orQualifiers);
			lesEngagements = EOQualifier.filteredArrayWithQualifier(lesEngagements, qualTypeEtat);
		}

		return null;
	}

	public Boolean isFiltreEtatEngageeChecked() {
		if (dg != null) {
			@SuppressWarnings("unchecked")
			NSDictionary<String, Object> bdgs = dg.queryBindings();
			if (bdgs != null) {
				@SuppressWarnings("unchecked")
				NSArray<String> lesTypesEtat = (NSArray<String>) bdgs.objectForKey("lesTypesEtat");
				if (lesTypesEtat != null && lesTypesEtat.containsObject(EOTypeEtat.ENGAGE)) {
					isFiltreEtatEngageeChecked = Boolean.TRUE;
				}
				else {
					isFiltreEtatEngageeChecked = Boolean.FALSE;
				}
			}
		}
		return isFiltreEtatEngageeChecked;
	}

	public void setIsFiltreEtatEngageeChecked(Boolean isFiltreEtatEngageeChecked) {
		this.isFiltreEtatEngageeChecked = isFiltreEtatEngageeChecked;
	}

	public Boolean isFiltreEtatPartiellementSoldeeChecked() {
		if (dg != null) {
			@SuppressWarnings("unchecked")
			NSDictionary<String, Object> bdgs = dg.queryBindings();
			if (bdgs != null) {
				@SuppressWarnings("unchecked")
				NSArray<String> lesTypesEtat = (NSArray<String>) bdgs.objectForKey("lesTypesEtat");
				if (lesTypesEtat != null && lesTypesEtat.containsObject(EOTypeEtat.PART_SOLDE)) {
					isFiltreEtatPartiellementSoldeeChecked = Boolean.TRUE;
				}
				else {
					isFiltreEtatPartiellementSoldeeChecked = Boolean.FALSE;
				}
			}
		}
		return isFiltreEtatPartiellementSoldeeChecked;
	}

	public void setIsFiltreEtatPartiellementSoldeeChecked(Boolean isFiltreEtatPartiellementSoldeeChecked) {
		this.isFiltreEtatPartiellementSoldeeChecked = isFiltreEtatPartiellementSoldeeChecked;
	}

	public Boolean isFiltreEtatSoldeeChecked() {
		if (dg != null) {
			@SuppressWarnings("unchecked")
			NSDictionary<String, Object> bdgs = dg.queryBindings();
			if (bdgs != null) {
				@SuppressWarnings("unchecked")
				NSArray<String> lesTypesEtat = (NSArray<String>) bdgs.objectForKey("lesTypesEtat");
				if (lesTypesEtat != null && lesTypesEtat.containsObject(EOTypeEtat.SOLDE)) {
					isFiltreEtatSoldeeChecked = Boolean.TRUE;
				}
				else {
					isFiltreEtatSoldeeChecked = Boolean.FALSE;
				}
			}
		}
		return isFiltreEtatSoldeeChecked;
	}

	public void setIsFiltreEtatSoldeeChecked(Boolean isFiltreEtatSoldeeChecked) {
		this.isFiltreEtatSoldeeChecked = isFiltreEtatSoldeeChecked;
	}

	public Boolean isFiltreEtatEngagee() {
		return filtreEtatEngagee;
	}

	public void setFiltreEtatEngagee(Boolean filtreEtatEngagee) {
		this.filtreEtatEngagee = filtreEtatEngagee;
	}

	public Boolean isFiltreEtatPartiellementSoldee() {
		return filtreEtatPartiellementSoldee;
	}

	public void setFiltreEtatPartiellementSoldee(Boolean filtreEtatPartiellementSoldee) {
		this.filtreEtatPartiellementSoldee = filtreEtatPartiellementSoldee;
	}

	public Boolean isFiltreEtatSoldee() {
		return filtreEtatSoldee;
	}

	public void setFiltreEtatSoldee(Boolean filtreEtatSoldee) {
		this.filtreEtatSoldee = filtreEtatSoldee;
	}

	public String getOnloadJS() {
		return onloadJS;
	}

	public void setOnloadJS(String onloadJS) {
		this.onloadJS = onloadJS;
	}

	@SuppressWarnings("unchecked")
	public NSArray<NSDictionary<String, Object>> getLesEngagements() {
		if (lesEngagements == null) {
			lesEngagements = getDg().allObjects();
		}
		return lesEngagements;
	}

	public void setLesEngagements(NSArray<NSDictionary<String, Object>> lesEngagements) {
		this.lesEngagements = lesEngagements;
	}

	//	public boolean isUtilisateurSansDroit() {
	//    	return !session.getUtilisateurAvecDroit().booleanValue();
	//    }

	public NSDictionary<String, Object> getUnEngagement() {
		return unEngagement;
	}

	public void setUnEngagement(NSDictionary<String, Object> unEngagement) {
		this.unEngagement = unEngagement;
	}

	public EOExercice getUnExercice() {
		return unExercice;
	}

	public void setUnExercice(EOExercice unExercice) {
		this.unExercice = unExercice;
	}

	public NSArray<EOTypeApplication> getLesApplications() {
		if (lesApplications == null) {
			lesApplications = FinderTypeApplication.getTypesApplication(edc());
		}
		return lesApplications;
	}

	public void setLesApplications(NSArray<EOTypeApplication> lesApplications) {
		this.lesApplications = lesApplications;
	}

	public EOTypeApplication getUneApplication() {
		return uneApplication;
	}

	public void setUneApplication(EOTypeApplication uneApplication) {
		this.uneApplication = uneApplication;
	}

	public WODisplayGroup getDg() {
		if (dg == null) {
			dg = (WODisplayGroup) valueForBinding("dg");
		}
		return dg;
	}

	public void setDg(WODisplayGroup dg) {
		this.dg = dg;
	}

	public NSArray<EOExercice> getLesExercices() {
		if (lesExercices == null) {
			lesExercices = FinderExercice.getExercices(edc());
		}
		return lesExercices;
	}

	public void setLesExercices(NSArray<EOExercice> lesExercices) {
		this.lesExercices = lesExercices;
	}

}